require "util"

script.on_init(function()

 --game.surfaces['nauvis'].daytime = .7
game.surfaces['nauvis'].daytime = .45
 -- For Testing
 game.speed = 1
 
-- Constants
global.TicksToUpdateBitersTarget =  600
global.SpawnMultiplier = 10
global.SpawnEveryXTicks = 600
global.ChanceToDropAmmo = 10
global.UnitSpawnSpeedUpPerRoundMultiple = 60

-- Counters
global.Round = -1
global.isNightTime = false
global.CurrentRoundSpawnDuration = 0
global.firstRun = true
global.CurrentTicksToUpdateBitersTarget = global.TicksToUpdateBitersTarget
global.UnitsSpawnedThisRound = 0
global.CheckNumberUnitsAliveCounter = 0;
global.TotalRoundEnemies = 0 
global.RoundForUnitCount = global.Round
global.EnemiesCanReachPlayer = false;


global.typeofunittospawn = "small-biter"

end)

script.on_event(defines.events, function(event)
   if event.name == defines.events.on_tick then
     -- handle on tick
     
   
     
     
	if (global.firstRun == true) then
  
		global.firstRun = false
		-- Make more of the map so that I can find spawns
		game.surfaces['nauvis'].request_to_generate_chunks({0,0}, 10)
    
	end
  
     -- Set Rounds
     if (game.surfaces['nauvis'].daytime >= .5 and game.surfaces['nauvis'].daytime < .7 and global.isNightTime == false ) then
     -- New Round Begins
      NewRoundBegins()
      
     elseif (game.surfaces['nauvis'].daytime >= .7 and global.isNightTime == true ) then
     
      -- Round Ends
      SendPrintToAllPlayers("Round Over")
      game.surfaces['nauvis'].freeze_daytime(false)
      
      global.isNightTime = false;
      
     end
     
     if (global.isNightTime == true) then
     
     -- Spawn units every x ticks until all units have spawned this round
      global.CurrentRoundSpawnDuration = global.CurrentRoundSpawnDuration +1;
      if (global.CurrentRoundSpawnDuration >= global.SpawnEveryXTicks and global.UnitsSpawnedThisRound < global.TotalRoundEnemies) then
        FindEnemySpawners()
        global.CurrentRoundSpawnDuration = 0
        
        
      end
      
      UpdateEnemyTargetLocation()
      
      CheckToSeeIfRoundOver()
      
     end
     if (global.isNightTime == false) then
       
     end
     
 end
  if event.name == defines.events.on_entity_died then
  
    if (event.entity.force==game.forces.enemy) then
    
      SendPrintToAllPlayers("Enemy Died")
      -- Chance to drop ammo
      if (math.random(0,100) > 100-global.ChanceToDropAmmo) then
          game.surfaces['nauvis'].create_entity{name="item-on-ground",position=event.entity.position,stack={name="firearm-magazine", count=10}}
      end
	  
	  -- Sometimes the enemy cant reach the player, if this line is hit, they can reach the player
	  global.EnemiesCanReachPlayer = true
      
    end
  end

 end)
 
 function NewRoundBegins()
      game.surfaces['nauvis'].freeze_daytime(true)
    global.isNightTime = true;
       global.Round = global.Round + 1;
       
       -- global.RoundForUnitCount resets back to 10 enemies when big units come out
       global.RoundForUnitCount = global.RoundForUnitCount + 1
      SendPrintToAllPlayers("Round "..global.Round)
	  SendPrintToAllPlayers(#game.players.." players")
      
	  -- New enemies at round 10
      if (global.Round == 8) then
        global.typeofunittospawn = "medium-biter"
        global.RoundForUnitCount = 1
      end
      
      -- New enemies at round 20
      if (global.Round == 15) then
        global.typeofunittospawn = "big-biter"
        global.RoundForUnitCount = 1
        
      end
      
      if (global.Round == 30) then
        global.typeofunittospawn = "behemoth-biter"
        global.RoundForUnitCount = 1
		global.SpawnMultiplier = 5
      end
      
      
       -- Spawn a new unit every x ticks during nighttime
      global.TotalRoundEnemies = global.SpawnMultiplier * global.RoundForUnitCount * #game.players
      if (global.Round ==0) then
        global.TotalRoundEnemies = 1
      end  
      SendPrintToAllPlayers(global.TotalRoundEnemies.." enemies this round")
  --    SendPrintToAllPlayers(global.UnitsSpawnedThisRound .." enemies spawned")
       
      
	  SendPrintToAllPlayers(global.typeofunittospawn)
      
      -- Speed up spawn rate 
    --  global.SpawnEveryXTicks = math.max(600 - (global.RoundForUnitCount*global.UnitSpawnSpeedUpPerRoundMultiple*#game.players),60)
      
 end
 
 function CheckToSeeIfRoundOver()
 
   -- To determine if a round has ended
       if (global.UnitsSpawnedThisRound >= global.TotalRoundEnemies) then
        -- Every 10 seconds, check to see how many enemies are alive
        if (global.CheckNumberUnitsAliveCounter == 600) then
          global.CheckNumberUnitsAliveCounter = 0
       
          local allbiters = game.surfaces['nauvis'].count_entities_filtered{force=game.forces.enemy,type="unit"}
          
          SendPrintToAllPlayers("Biters alive: "..allbiters)
          -- Round over when all units are dead, back to day time
          if (allbiters == 0) then
            game.surfaces['nauvis'].daytime = .8
            global.UnitsSpawnedThisRound = 0
            global.CheckNumberUnitsAliveCounter = 0
            global.CurrentRoundSpawnDuration = 0
			
			-- if the enemies cant reach the player, then notify
			if (global.Round == 0 and global.EnemiesCanReachPlayer == false) then
				SendPrintToAllPlayers("Enemies can't reach you, restart map")
				game.surfaces['nauvis'].freeze_daytime(true)
			end
            
          end
         end
         global.CheckNumberUnitsAliveCounter = global.CheckNumberUnitsAliveCounter+1
       end
 
 end
 
 function UpdateEnemyTargetLocation()
 
 -- Update all enemies, have their target location go to wherever the player has moved to
      global.CurrentTicksToUpdateBitersTarget = global.CurrentTicksToUpdateBitersTarget-1
      if (global.CurrentTicksToUpdateBitersTarget == 0) then
        global.CurrentTicksToUpdateBitersTarget = global.TicksToUpdateBitersTarget
        local allbiters = game.surfaces['nauvis'].find_entities_filtered{force=game.forces.enemy,type="unit"}
        for i,v in pairs(allbiters)  do
          local totalplayers = #game.players
          local playertotargetindex = mod(i,totalplayers)+1
          -- Take turns, have units target each player
          v.set_command({type=defines.command.go_to_location, destination=game.players[1].position})
		  -- /c game.players[1].print(game.players[2].position.x)
        end
      end
 
 end
 
 

function mod(a, b)
return a - (math.floor(a/b))
end

 
 
 function KillAllEnemyUnits()
 
  local allbiters = game.surfaces['nauvis'].find_entities_filtered{force=game.forces.enemy,type="unit"}
        for i,v in pairs(allbiters)  do
          v.destroy() 
        end
 
 end
 
 function spawnEnemies(enemyposition)
 
    local playerpos = game.players[1].position
    
	
	local numbertospawn = global.RoundForUnitCount
--	local numbertospawn = 5*math.floor(global.Round/5)
	if (numbertospawn == 0) then
		numbertospawn = 1
	end
	local counter = 0

	while counter < numbertospawn do
		enemyposition.x = enemyposition.x + 10 + counter
    -- Spawn an enemy at closest unit spawner
		local thisbiter = game.surfaces['nauvis'].create_entity{name=global.typeofunittospawn,position=enemyposition,force=game.forces.enemy, target=game.players[1].character}
		
		-- Send him to  player 1
		thisbiter.set_command({type=defines.command.go_to_location, destination=playerpos})
		
		global.UnitsSpawnedThisRound = global.UnitsSpawnedThisRound + 1
		
		
		counter = counter + 1
	end
	SendPrintToAllPlayers("sending "..numbertospawn.. " biters")
  
 end
 
 function SendPrintToAllPlayers(message)
 
   for i,v in pairs(game.players)  do
          v.print(message)
   end
 
 end
 
 function FindEnemySpawners()
 
  -- look for the closest enemy unit spawner, that is where new units will come from
  local searcharea = 10  
  local enemyunitspawner = game.surfaces['nauvis'].find_entities_filtered{area = {{-1*searcharea, -1*searcharea}, {searcharea, searcharea}}, type= "unit-spawner"} 
  while next(enemyunitspawner)  == nil and searcharea < 2000 do
    searcharea = searcharea * 2
    enemyunitspawner = game.surfaces['nauvis'].find_entities_filtered{area = {{-1*searcharea, -1*searcharea}, {searcharea, searcharea}}, type= "unit-spawner"} 
    
  end
 -- game.players[1].print("base found within " .. searcharea .. " units")

   
  spawnEnemies(enemyunitspawner[1].position)
  
 end
 
 
 